/**
   BasicHTTPClient.ino

    Created on: 24.05.2015

*/

#include <Arduino.h>
#include <ESP8266WiFi.h>
#include <ESP8266WiFiMulti.h>
#include <ESP8266HTTPClient.h>
#include <WiFiClient.h>

ESP8266WiFiMulti WiFiMulti;

const int analogInPin = A0;  // ESP8266 Analog Pin ADC0 = A0
int sensorValue = 0;  // value read from the pot
String endpoint = "http://192.168.2.207:3000/sensorvalue"; //put your webservice endpoint here

void setup() {

  Serial.begin(115200);
  // Serial.setDebugOutput(true);

  Serial.println();
  Serial.println();
  Serial.println();

  for (uint8_t t = 4; t > 0; t--) {
    Serial.printf("[SETUP] WAIT %d...\n", t);
    Serial.flush();
    delay(1000);
  }

  WiFi.mode(WIFI_STA);
  WiFiMulti.addAP("bathurst-home", "HonestEdsIn416");

}

void loop() {
  // wait for WiFi connection
  sensorValue = analogRead(analogInPin);
  String stringOne = "{\"sensorvalue\": ";
  String stringTwo = "}";
  String stringThree = stringOne + sensorValue + stringTwo;
  Serial.println(stringThree); 
//  String sensorjson = "{\"sensorvalue\": " + sensorValue + "}";
//  Serial.print(sensorjson);
    
  if ((WiFiMulti.run() == WL_CONNECTED)) {

    WiFiClient client;

    HTTPClient http;

    Serial.print("[HTTP] begin...\n");
    if (http.begin(client, endpoint)) {  // HTTP


      Serial.print("[HTTP] GET...\n");
      // start connection and send HTTP header
      http.addHeader("Content-Type", "application/json");
      int httpCode = http.POST(stringThree);


      // httpCode will be negative on error
      if (httpCode > 0) {
        // HTTP header has been send and Server response header has been handled
        Serial.printf("[HTTP] GET... code: %d\n", httpCode);

        // file found at server
        if (httpCode == HTTP_CODE_OK || httpCode == HTTP_CODE_MOVED_PERMANENTLY) {
          String payload = http.getString();
          Serial.println(payload);
        }
      } else {
        Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
      }

      http.end();
    } else {
      Serial.printf("[HTTP} Unable to connect\n");
    }
  }

  delay(10000);
}
